<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>tools/celhpf.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tools/celhpf.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2010 by Leonardo Rodrigo Domingues</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_HPFAPI__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_HPFAPI__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/list_8h.html">csutil/list.h</a>&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;tools/celnavmesh.h&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBox3.html">csBox3</a>;
<a name="l00028"></a>00028 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsOBB.html">csOBB</a>;
<a name="l00029"></a>00029 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>;
<a name="l00030"></a>00030 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>;
<a name="l00031"></a>00031 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structcsSimpleRenderMesh.html">csSimpleRenderMesh</a>;
<a name="l00032"></a>00032 <span class="keyword">struct </span><a class="code" href="structiCelNavMeshParams.html" title="Wrapper for the parameters used to build the navigation mesh.">iCelNavMeshParams</a>;
<a name="l00033"></a>00033 <span class="keyword">struct </span><a class="code" href="structiCelPath.html" title="Interface for CEL Path.">iCelPath</a>;
<a name="l00034"></a>00034 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>;
<a name="l00035"></a>00035 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSectorList.html">iSectorList</a>;
<a name="l00036"></a>00036 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMapNode.html">iMapNode</a>;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00043"></a><a class="code" href="structiCelHPath.html">00043</a> <span class="keyword">struct </span><a class="code" href="structiCelHPath.html" title="Hierarchical path between two points.">iCelHPath</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   SCF_INTERFACE (<a class="code" href="structiCelHPath.html" title="Hierarchical path between two points.">iCelHPath</a>, 1, 0, 0);
<a name="l00046"></a>00046 
<a name="l00048"></a>00048   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelHPath.html#a45de7b22009c5022bee0bd20101784d3" title="Check if the path can be transversed forward from the current position.">HasNext</a> () <span class="keyword">const</span> = 0;
<a name="l00049"></a>00049 
<a name="l00051"></a>00051   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelHPath.html#aa3fcfae751a258fab2042a52dd9cb66f" title="Check if the path can be transversed backward from the current position.">HasPrevious</a> () <span class="keyword">const</span> = 0;
<a name="l00052"></a>00052 
<a name="l00054"></a>00054   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMapNode.html">iMapNode</a>* <a class="code" href="structiCelHPath.html#a35d4b7fe8a19cb20e4d7448cadb25dcc" title="Get next node.">Next</a> () = 0;
<a name="l00055"></a>00055   
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMapNode.html">iMapNode</a>* <a class="code" href="structiCelHPath.html#a07d7c29607c3075f8a4a6345ea9b81b8" title="Get previous node.">Previous</a> () = 0;
<a name="l00058"></a>00058     
<a name="l00060"></a>00060   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMapNode.html">iMapNode</a>* <a class="code" href="structiCelHPath.html#addcc2a1187b2d456b0f2afc00f4aaa67" title="Get current node.">Current</a> () = 0;
<a name="l00061"></a>00061 
<a name="l00063"></a>00063   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMapNode.html">iMapNode</a>* <a class="code" href="structiCelHPath.html#abca8b55fe390816d4708e75b7db40857" title="Get first node.">GetFirst</a> () = 0;
<a name="l00064"></a>00064   
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMapNode.html">iMapNode</a>* <a class="code" href="structiCelHPath.html#a37c75dc0b6d2eb240c305c64b9ec39df" title="Get last node.">GetLast</a> () = 0;
<a name="l00067"></a>00067   
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelHPath.html#a64615ab0f8da11610260dd4a0e705363" title="Invert path.">Invert</a> () = 0;
<a name="l00070"></a>00070 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelHPath.html#a8bc98961ee7124f1b907f2200d4839a6" title="Restart path.">Restart</a> () = 0;
<a name="l00073"></a>00073 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelHPath.html#a8895860883c57b1a65de1bcaf8cd26b4" title="Distance to goal.">GetDistance</a> () <span class="keyword">const</span> = 0;
<a name="l00076"></a>00076   
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsList.html">csList&lt;csSimpleRenderMesh&gt;</a>* <a class="code" href="structiCelHPath.html#a00e4f508d3880ecd184991624d0efd44" title="Render path.">GetDebugMeshes</a> () = 0;
<a name="l00082"></a>00082 };
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00089"></a><a class="code" href="structiCelHNavStruct.html">00089</a> <span class="keyword">struct </span><a class="code" href="structiCelHNavStruct.html" title="Hierarchical navigation structure representing the navigable areas of a Map.">iCelHNavStruct</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00090"></a>00090 {
<a name="l00091"></a>00091   SCF_INTERFACE (<a class="code" href="structiCelHNavStruct.html" title="Hierarchical navigation structure representing the navigable areas of a Map.">iCelHNavStruct</a>, 1, 0, 0);
<a name="l00092"></a>00092 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <a class="code" href="structiCelHPath.html" title="Hierarchical path between two points.">iCelHPath</a>* <a class="code" href="structiCelHNavStruct.html#a9aae8e405cef7babc7e08b087c254689" title="Find the shortest path between two points.">ShortestPath</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; from, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* fromSector, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; goal,
<a name="l00104"></a>00104     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* goalSector) = 0;
<a name="l00105"></a>00105 
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <a class="code" href="structiCelHPath.html" title="Hierarchical path between two points.">iCelHPath</a>* <a class="code" href="structiCelHNavStruct.html#a9aae8e405cef7babc7e08b087c254689" title="Find the shortest path between two points.">ShortestPath</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMapNode.html">iMapNode</a>* from, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMapNode.html">iMapNode</a>* goal) = 0;
<a name="l00115"></a>00115   
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelHNavStruct.html#a02229fa564d6e9f85ffd41565a660d85" title="Update the tiles of the hierarchical navigation structure that intersect with an axis aligned boundin...">Update</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBox3.html">csBox3</a>&amp; boundingBox, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector = 0) = 0;
<a name="l00124"></a>00124 
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelHNavStruct.html#a02229fa564d6e9f85ffd41565a660d85" title="Update the tiles of the hierarchical navigation structure that intersect with an axis aligned boundin...">Update</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsOBB.html">csOBB</a>&amp; boundingBox, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector = 0) = 0;
<a name="l00133"></a>00133 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelHNavStruct.html#af75a218a30e1f2c20b15dccdef077cc4" title="Save this structure to a file.">SaveToFile</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiVFS.html">iVFS</a>* vfs, <span class="keyword">const</span> <span class="keywordtype">char</span>* directory) = 0;
<a name="l00142"></a>00142 
<a name="l00147"></a>00147   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structiCelNavMeshParams.html" title="Wrapper for the parameters used to build the navigation mesh.">iCelNavMeshParams</a>* <a class="code" href="structiCelHNavStruct.html#a68fd614d3725f492a56ea93995adb334" title="Get an object representation of the navigation mesh parameters.">GetNavMeshParams</a> () <span class="keyword">const</span> = 0;
<a name="l00148"></a>00148 
<a name="l00153"></a>00153   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsList.html">csList&lt;csSimpleRenderMesh&gt;</a>* <a class="code" href="structiCelHNavStruct.html#aa3615d5cf25b84ce7dd2a2b6e0979754" title="Render navigation structure.">GetDebugMeshes</a> () <span class="keyword">const</span> = 0;
<a name="l00154"></a>00154 
<a name="l00159"></a>00159   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsList.html">csList&lt;csSimpleRenderMesh&gt;</a>* <a class="code" href="structiCelHNavStruct.html#ad56e47aa4f34d3e49f2415960b528801" title="Render proxy agent of the specified color.">GetAgentDebugMeshes</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos, <span class="keywordtype">int</span> red, <span class="keywordtype">int</span> green,
<a name="l00160"></a>00160                                                            <span class="keywordtype">int</span> blue, <span class="keywordtype">int</span> alpha) <span class="keyword">const</span> = 0;
<a name="l00161"></a>00161 };
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00168"></a><a class="code" href="structiCelHNavStructBuilder.html">00168</a> <span class="keyword">struct </span><a class="code" href="structiCelHNavStructBuilder.html" title="Hierarchical navigation struct creator.">iCelHNavStructBuilder</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00169"></a>00169 {
<a name="l00170"></a>00170   SCF_INTERFACE (<a class="code" href="structiCelHNavStructBuilder.html" title="Hierarchical navigation struct creator.">iCelHNavStructBuilder</a>, 1, 0, 0);
<a name="l00171"></a>00171 
<a name="l00179"></a>00179   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelHNavStructBuilder.html#a6c9105834e223d0016d0b15a16240a48" title="Set the Sectors used to build the navigation structure.">SetSectors</a>(<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsList.html">csList&lt;iSector*&gt;</a> sectorList) = 0;
<a name="l00180"></a>00180 
<a name="l00185"></a>00185   <span class="keyword">virtual</span> <a class="code" href="structiCelHNavStruct.html" title="Hierarchical navigation structure representing the navigable areas of a Map.">iCelHNavStruct</a>* <a class="code" href="structiCelHNavStructBuilder.html#a7dc5f23c72d14e8581192db8bdd7eb41" title="Build a hierarchical navigation structure using the current configurations.">BuildHNavStruct</a> () = 0;
<a name="l00186"></a>00186 
<a name="l00194"></a>00194   <span class="keyword">virtual</span> <a class="code" href="structiCelHNavStruct.html" title="Hierarchical navigation structure representing the navigable areas of a Map.">iCelHNavStruct</a>* <a class="code" href="structiCelHNavStructBuilder.html#a3b9fcb278170707d6396afaa3bdc1fcf" title="Load a hierarchical navigation structure from a file.">LoadHNavStruct</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiVFS.html">iVFS</a>* vfs, <span class="keyword">const</span> <span class="keywordtype">char</span>* directory) = 0;
<a name="l00195"></a>00195 
<a name="l00200"></a>00200   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structiCelNavMeshParams.html" title="Wrapper for the parameters used to build the navigation mesh.">iCelNavMeshParams</a>* <a class="code" href="structiCelHNavStructBuilder.html#a94f6f032ca52df67b38faffa51ee620d" title="Get an object representation of the navigation mesh parameters.">GetNavMeshParams</a> () <span class="keyword">const</span> = 0;
<a name="l00201"></a>00201 
<a name="l00206"></a>00206   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelHNavStructBuilder.html#aa1168b4313ef8553477420825198bf9a" title="Set navigation mesh parameters.">SetNavMeshParams</a> (<span class="keyword">const</span> <a class="code" href="structiCelNavMeshParams.html" title="Wrapper for the parameters used to build the navigation mesh.">iCelNavMeshParams</a>* parameters) = 0;
<a name="l00207"></a>00207 };
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 <span class="preprocessor">#endif // __CEL_HPFAPI__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
